define(
	'GoogleTagManager.Extension'
,	[
	'GoogleTagManager'
,	'Tracker'
,	'underscore'
	]

,	function (
	GoogleTagManager
,	Tracker
,	_
	)

{

	'use strict';

			_.extend(GoogleTagManager.prototype,
			{
				trackProductView: function (product)
				{
					var item = product.getItem();

					if (this.item && this.item.get('itemId') === item.get('_id'))

					{
						item.set('category', this.item.get('category'), { silent: true });
						item.set('list', this.item.get('list'), { silent: true });
					}

					var eventName = 'productView'
					,	selected_options = product.get('options').filter(function (option)
						{
							return option.get('value') && option.get('value').label;
						})
					,	price = product.getPrice()
					,	eventData = {
						'event': eventName
					,	'data': {
							'sku': product.getSku()
						,	'name': item.get('_name')
						,	'variant': _.map(selected_options, function (option)
								{
									return option.get('value').label;
								}).join(', ')
						,	'price': ((price.price) ? price.price : 0).toFixed(2)
						,	'category': item.get('category') || '' // as we do not support categories this is just the url
						,	'list': item.get('list') || ''
						,	'page': this.getCategory()
						}
					};

					this.item = null;

					//Triggers a Backbone.Event so others can subscribe to this event and add/replace data before is send it to Google Tag Manager
					Tracker.trigger(eventName, eventData, item);
					this.pushData(eventData);

					return this;
				}
			});	
});	